/**
 * Title:        Checklist
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      University Bayreuth
 * @author Dieter Neubacher
 * @version 1.0
 */

package net.metadiversity.diversity.navigator.checklists.taxon;

import net.metadiversity.diversity.navigator.checklists.*;

public class Taxon extends javax.swing.JPanel
{

/**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3257854281087725878L;

// Variables declaration - do not modify
private javax.swing.JLabel jLabelTaxon;

private javax.swing.JPanel jPanelInputFieldsTaxon;
private javax.swing.JPanel jPanelValidity;
private javax.swing.JPanel jPanelRadioButtons;
private javax.swing.JPanel jPanelOutputLine;
private javax.swing.JPanel jPanelLiterature;
private javax.swing.JPanel jPanel_OGU_distribution;
private javax.swing.JPanel jPanel_OGU_type;
private javax.swing.JPanel jPanel_OGU;
private javax.swing.JPanel jPanelNotice;
private javax.swing.JPanel jPanelReference;

private javax.swing.JLabel jLabelGenus;
private javax.swing.JLabel jLabelSpecies;
private javax.swing.JLabel jLabelSubSpecies;
private javax.swing.JLabel jLabelVariety;
private javax.swing.JLabel jLabelForm;
private javax.swing.JLabel jLabelFirst;
private javax.swing.JLabel jLabelAuthor;
private javax.swing.JLabel jLabelOutputLine;

private javax.swing.JTextField jTextFieldGenus;
private javax.swing.JTextField jTextFieldSpecies;
private javax.swing.JTextField jTextFieldSubSpecies;
private javax.swing.JTextField jTextFieldVariety;
private javax.swing.JTextField jTextFieldForm;
private javax.swing.JTextField jTextFieldFirst;
private javax.swing.JTextField jTextFieldAuthor;
private javax.swing.JTextField jTextFieldLiterature;
private javax.swing.JTextField jTextFieldLiteratureYear;
private javax.swing.JTextField jTextFieldReference;
private javax.swing.JTextField jTextField_OGU_distribution;
private javax.swing.JTextField jTextField_OGU_type;

private javax.swing.JTextArea jTextAreaNotice;
//------------------------------------------------------------------------------
private javax.swing.JLabel jLabel_1_0;
private javax.swing.JRadioButton jRadioButtonUnkown1;
private javax.swing.JRadioButton jRadioButtonNonSynonym;
private javax.swing.JRadioButton jRadioButtonSynonym;
private javax.swing.JLabel jLabel_1_4;
private javax.swing.JLabel jLabel_1_5;
private javax.swing.JLabel jLabel_1_6;
private javax.swing.JLabel jLabel_1_7;
private javax.swing.JLabel jLabel_1_8;
//------------------------------------------------------------------------------

private javax.swing.JLabel jLabel_2_0;
private javax.swing.JRadioButton jRadioButtonUnkown2;
private javax.swing.JRadioButton jRadioButtonBasionym;
private javax.swing.JRadioButton jRadioButtonCombined;
private javax.swing.JLabel jLabel_2_4;
private javax.swing.JLabel jLabel_2_5;
private javax.swing.JLabel jLabel_2_6;
private javax.swing.JLabel jLabel_2_7;
private javax.swing.JLabel jLabel_2_8;

//------------------------------------------------------------------------------
private javax.swing.JLabel jLabel_3_0;
private javax.swing.JRadioButton jRadioButtonUnkown3;
private javax.swing.JRadioButton jRadioButtonValid;
private javax.swing.JRadioButton jRadioButtonNomenNudum;
private javax.swing.JRadioButton jRadioButtonNomenIlleg;
private javax.swing.JRadioButton jRadioButtonNomenInvalid;
private javax.swing.JRadioButton jRadioButtonAuct;
private javax.swing.JRadioButton jRadioButtonAgg;
private javax.swing.JRadioButton jRadioButtonIned;

//------------------------------------------------------------------------------
private javax.swing.JLabel jLabel_4_0;
private javax.swing.JLabel jLabel_4_1;
private javax.swing.JLabel jLabel_4_2;
private javax.swing.JLabel jLabel_4_3;
private javax.swing.JLabel jLabel_4_4;
private javax.swing.JLabel jLabel_4_5;
private javax.swing.JLabel jLabel_4_6;
private javax.swing.JLabel jLabel_4_7;
private javax.swing.JLabel jLabel_4_8;


private javax.swing.JLabel jLabelValidity;
private javax.swing.JLabel jLabelLiterature;
private javax.swing.JLabel jLabelLiteratureYear;
private javax.swing.JLabel jLabelNotice;


// ??? private javax.swing.JLabel jLabelEmpty;
private javax.swing.JLabel jLabel_OGU_type;
private javax.swing.JLabel jLabel_OGU_distribution;
private javax.swing.JLabel jLabelReference;
private javax.swing.JLabel jLabelReferenceAuthor;

// End of variables declaration

    /** Creates new form Taxon */
    public Taxon()
    {
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents ()
    {
        jPanelInputFieldsTaxon   = new javax.swing.JPanel();
        jPanelValidity           = new javax.swing.JPanel();
        jPanelRadioButtons       = new javax.swing.JPanel();
        jPanelOutputLine         = new javax.swing.JPanel();
        jPanelLiterature         = new javax.swing.JPanel();
        jPanel_OGU               = new javax.swing.JPanel();
        jPanel_OGU_type          = new javax.swing.JPanel();
        jPanel_OGU_distribution  = new javax.swing.JPanel();
        jPanelNotice             = new javax.swing.JPanel();
        jPanelReference          = new javax.swing.JPanel();

        jLabelTaxon              = new javax.swing.JLabel();
        jLabelGenus              = new javax.swing.JLabel();
        jLabelSpecies            = new javax.swing.JLabel();
        jLabelSubSpecies         = new javax.swing.JLabel();
        jLabelVariety            = new javax.swing.JLabel();
        jLabelForm               = new javax.swing.JLabel();
        jLabelFirst              = new javax.swing.JLabel();
        jLabelAuthor             = new javax.swing.JLabel();

	jLabelOutputLine         = new javax.swing.JLabel();
        jLabelOutputLine.setForeground( java.awt.Color.red );
        jLabelOutputLine.setFont( new java.awt.Font ( "Dialog", 1, 12 ) );
        jLabelOutputLine.setHorizontalAlignment( javax.swing.SwingConstants.CENTER );

        jTextFieldGenus          = new javax.swing.JTextField ();
        jTextFieldSpecies        = new javax.swing.JTextField ();
        jTextFieldSubSpecies     = new javax.swing.JTextField ();
        jTextFieldVariety        = new javax.swing.JTextField ();
        jTextFieldForm           = new javax.swing.JTextField ();
        jTextFieldFirst          = new javax.swing.JTextField ();
        jTextFieldAuthor         = new javax.swing.JTextField ();
        jLabelValidity           = new javax.swing.JLabel ();

        // 1. line
        //----------------------------------------------------------------------

        jLabel_1_0 = new javax.swing.JLabel();

        jRadioButtonUnkown1      = new javax.swing.JRadioButton();
        jRadioButtonNonSynonym   = new javax.swing.JRadioButton();
        jRadioButtonSynonym      = new javax.swing.JRadioButton();

        jLabel_1_4 = new javax.swing.JLabel();
        jLabel_1_5 = new javax.swing.JLabel();
        jLabel_1_6 = new javax.swing.JLabel();
        jLabel_1_7 = new javax.swing.JLabel();
        jLabel_1_8 = new javax.swing.JLabel();

        // 2. line
        //----------------------------------------------------------------------
        jLabel_2_0 = new javax.swing.JLabel();

        jRadioButtonUnkown2      = new javax.swing.JRadioButton ();
        jRadioButtonBasionym     = new javax.swing.JRadioButton ();
        jRadioButtonCombined     = new javax.swing.JRadioButton ();

        jLabel_2_4 = new javax.swing.JLabel();
        jLabel_2_5 = new javax.swing.JLabel();
        jLabel_2_6 = new javax.swing.JLabel();
        jLabel_2_7 = new javax.swing.JLabel();
        jLabel_2_8 = new javax.swing.JLabel();

        // 3. line
        //----------------------------------------------------------------------
        jLabel_3_0 = new javax.swing.JLabel();

        jRadioButtonUnkown3      = new javax.swing.JRadioButton ();
        jRadioButtonValid        = new javax.swing.JRadioButton ();
        jRadioButtonNomenNudum   = new javax.swing.JRadioButton ();
        jRadioButtonNomenIlleg   = new javax.swing.JRadioButton ();
        jRadioButtonNomenInvalid = new javax.swing.JRadioButton ();
        jRadioButtonAuct         = new javax.swing.JRadioButton ();
        jRadioButtonAgg          = new javax.swing.JRadioButton ();
        jRadioButtonIned         = new javax.swing.JRadioButton ();

        // 4. line
        //----------------------------------------------------------------------
        jLabel_4_0 = new javax.swing.JLabel();
        jLabel_4_1 = new javax.swing.JLabel();
        jLabel_4_2 = new javax.swing.JLabel();
        jLabel_4_3 = new javax.swing.JLabel();
        jLabel_4_4 = new javax.swing.JLabel();
        jLabel_4_5 = new javax.swing.JLabel();
        jLabel_4_6 = new javax.swing.JLabel();
        jLabel_4_7 = new javax.swing.JLabel();
        jLabel_4_8 = new javax.swing.JLabel();

	// set Unkown as default

	jRadioButtonUnkown1.setSelected( true );
	jRadioButtonUnkown2.setSelected( true );
	jRadioButtonUnkown3.setSelected( true );


        jLabelLiterature = new javax.swing.JLabel ();
        jTextFieldLiterature = new javax.swing.JTextField ();
        jLabelLiteratureYear = new javax.swing.JLabel ();
        jTextFieldLiteratureYear = new javax.swing.JTextField ();
        jLabel_OGU_type = new javax.swing.JLabel ();
        jTextField_OGU_type = new javax.swing.JTextField ();
        jLabel_OGU_distribution = new javax.swing.JLabel ();
        jTextField_OGU_distribution = new javax.swing.JTextField ();
        jLabelNotice = new javax.swing.JLabel ();
        jTextAreaNotice = new javax.swing.JTextArea ();
        jLabelReference = new javax.swing.JLabel ();
        jTextFieldReference = new javax.swing.JTextField ();
        jLabelReferenceAuthor = new javax.swing.JLabel ();
	//-------------------------------------------------------------------------
	//-------------------------------------------------------------------------
        setLayout( new java.awt.GridLayout( 9, 1) );

	//-----------------------
	// Headline
	//-----------------------

        jLabelTaxon.setText( "Taxon:" );
        jLabelTaxon.setHorizontalAlignment( javax.swing.SwingConstants.CENTER );
        jLabelTaxon.setFont( new java.awt.Font( "Dialog", 0, 18) );
        add( jLabelTaxon);

	//-----------------------
	// Input Fields for taxon
	//-----------------------

        TaxonInput jPanelInputFieldsTaxon = new TaxonInput( jLabelOutputLine );
        add( jPanelInputFieldsTaxon );
/*
        jPanelInputFieldsTaxon.setLayout( new java.awt.GridLayout (2, 8) );

	jLabelGenus.setText(      "genus" );
	jLabelSpecies.setText(    "species" );
	jLabelSubSpecies.setText( "subspecies" );
	jLabelVariety.setText(    "variety" );
	jLabelForm.setText(       "form" );
	jLabelFirst.setText(      "(author)" );
	jLabelAuthor.setText(     "author" );

	jPanelInputFieldsTaxon.add( jLabelGenus );
	jPanelInputFieldsTaxon.add( jLabelSpecies );
	jPanelInputFieldsTaxon.add( jLabelSubSpecies );
	jPanelInputFieldsTaxon.add( jLabelVariety );
	jPanelInputFieldsTaxon.add( jLabelForm );
	jPanelInputFieldsTaxon.add( jLabelFirst );
	jPanelInputFieldsTaxon.add( jLabelAuthor );

	//--------
	// genus
	//--------

	jTextFieldGenus.setText( "" );
	jTextFieldGenus.addKeyListener( new java.awt.event.KeyAdapter ()
        {
            public void keyReleased( java.awt.event.KeyEvent evt )
            {
		showOutputLine();
            }
        }
	);
	jTextFieldGenus.addActionListener (new java.awt.event.ActionListener ()
	    {
	    public void actionPerformed (java.awt.event.ActionEvent evt)
	    {
		jTextFieldGenusActionPerformed (evt);
	    }
	    }
	);
	jPanelInputFieldsTaxon.add( jTextFieldGenus);

	//--------
	// species
	//--------

	jTextFieldSpecies.setText ("");
	jTextFieldSpecies.addKeyListener( new java.awt.event.KeyAdapter ()
        {
            public void keyReleased( java.awt.event.KeyEvent evt )
            {
		showOutputLine();
            }
        }
	);
	jTextFieldSpecies.addActionListener (new java.awt.event.ActionListener ()
	    {
		public void actionPerformed (java.awt.event.ActionEvent evt)
		{
		    jTextFieldSpeciesActionPerformed( evt );

		    // Output
		    System.out.println( "Event: Species" );
		    jLabelOutputLine.setText( jTextFieldSpecies.getText() );
		    jLabelOutputLine.setVisible( true );
		}
	    }
	);
	jPanelInputFieldsTaxon.add( jTextFieldSpecies);

	//--------
	// subspecies
	//--------

	jTextFieldSubSpecies.setText ("");
	jTextFieldSubSpecies.addKeyListener( new java.awt.event.KeyAdapter ()
        {
            public void keyReleased( java.awt.event.KeyEvent evt )
            {
		showOutputLine();
            }
        }
	);
	jTextFieldSubSpecies.addActionListener (new java.awt.event.ActionListener ()
	    {
		public void actionPerformed (java.awt.event.ActionEvent evt)
		{
		    jTextFieldSubSpeciesActionPerformed (evt);
		}
	    }
	);
	jPanelInputFieldsTaxon.add( jTextFieldSubSpecies);

	//--------
	// variety
	//--------

	jTextFieldVariety.setText ("");
	jTextFieldVariety.addKeyListener( new java.awt.event.KeyAdapter ()
        {
            public void keyReleased( java.awt.event.KeyEvent evt )
            {
		showOutputLine();
            }
        }
	);
	jTextFieldVariety.addActionListener (new java.awt.event.ActionListener ()
	    {
		public void actionPerformed (java.awt.event.ActionEvent evt)
		{
		    jTextFieldVarietyActionPerformed (evt);
		}
	    }
	);
	jPanelInputFieldsTaxon.add( jTextFieldVariety );

	//--------
	// form
	//--------

	jTextFieldForm.setText ("");
	jTextFieldForm.addKeyListener( new java.awt.event.KeyAdapter ()
        {
            public void keyReleased( java.awt.event.KeyEvent evt )
            {
		showOutputLine();
            }
        }
	);
	jTextFieldForm.addActionListener (new java.awt.event.ActionListener ()
	    {
		public void actionPerformed (java.awt.event.ActionEvent evt)
		{
		    jTextFieldFormActionPerformed (evt);
		}
	    }
	);
	jPanelInputFieldsTaxon.add( jTextFieldForm );

	//--------
	// first
	//--------

	jTextFieldFirst.setText ("");
	jTextFieldFirst.addKeyListener( new java.awt.event.KeyAdapter ()
        {
            public void keyReleased( java.awt.event.KeyEvent evt )
            {
		showOutputLine();
            }
        }
	);
	jTextFieldFirst.addActionListener (new java.awt.event.ActionListener ()
	    {
		public void actionPerformed (java.awt.event.ActionEvent evt)
		{
		    jTextFieldFirstActionPerformed (evt);
		}
	    }
	);
	jPanelInputFieldsTaxon.add( jTextFieldFirst );

	//--------
	// author
	//--------

	jTextFieldAuthor.setText( "" );
	jTextFieldAuthor.addKeyListener( new java.awt.event.KeyAdapter ()
        {
            public void keyReleased( java.awt.event.KeyEvent evt )
            {
		showOutputLine();
            }
        }
	);
	jTextFieldAuthor.addActionListener (new java.awt.event.ActionListener ()
	    {
		public void actionPerformed (java.awt.event.ActionEvent evt)
		{
		    jTextFieldAuthorActionPerformed (evt);
		}
	    }
	 );

	jPanelInputFieldsTaxon.add( jTextFieldAuthor);
        add( jPanelInputFieldsTaxon);
*/
	//-------------------------------------------------------------------------
	// RadioButtens for validity
	//-------------------------------------------------------------------------

	/****
          jLabelValidity.setText( "validity:" );
          jLabelValidity.setHorizontalAlignment( javax.swing.SwingConstants.LEFT );
          jLabelValidity.setVerticalAlignment(   javax.swing.SwingConstants.CENTER );

	  jPanelValidity.setLayout( new java.awt.FlowLayout( 0, 5, 5) );
          jPanelValidity.add( jLabelValidity);
        add( jPanelValidity );
	****/

        jPanelRadioButtons.setLayout( new java.awt.GridLayout( 2, 4 ) );

	  //-------------------------------------------------------------------------
	  //-------------------------------------------------------------------------
          jRadioButtonUnkown1.setText( "unkown" );
	  jRadioButtonUnkown1.addKeyListener( new java.awt.event.KeyAdapter ()
	  {
	      public void keyReleased( java.awt.event.KeyEvent evt )
	      {
                  setUnkown1();
	      }
	  }
	  );
          jRadioButtonUnkown1.addActionListener (new java.awt.event.ActionListener ()
          {
              public void actionPerformed( java.awt.event.ActionEvent evt )
              {
                  setUnkown1();
              }
          }
          );
          jRadioButtonNonSynonym.setText( "non-synonym" );
	  jRadioButtonNonSynonym.addKeyListener( new java.awt.event.KeyAdapter ()
	  {
	      public void keyReleased( java.awt.event.KeyEvent evt )
	      {
                  setNonSynonym();
	      }
	  }
	  );
          jRadioButtonNonSynonym.addActionListener (new java.awt.event.ActionListener ()
          {
              public void actionPerformed (java.awt.event.ActionEvent evt)
              {
                  setNonSynonym();
              }
          }
          );
          jRadioButtonSynonym.setText( "synonym" );
	  jRadioButtonSynonym.addKeyListener( new java.awt.event.KeyAdapter ()
	  {
	      public void keyReleased( java.awt.event.KeyEvent evt )
	      {
                  setSynonym();
	      }
	  }
	  );
          jRadioButtonSynonym.addActionListener (new java.awt.event.ActionListener ()
          {
              public void actionPerformed (java.awt.event.ActionEvent evt)
              {
                  setSynonym();
              }
          }
          );
/*
	  jLabel_1_0.setText( "synonymity:" );
          jPanelRadioButtons.add( jLabel_1_0 );
          jPanelRadioButtons.add( jRadioButtonUnkown1);
          jPanelRadioButtons.add( jRadioButtonNonSynonym);
          jPanelRadioButtons.add( jRadioButtonSynonym );
          jPanelRadioButtons.add( jLabel_1_4 );
	  jPanelRadioButtons.add( jLabel_1_5 );
          jPanelRadioButtons.add( jLabel_1_6 );
*/
//          jPanelRadioButtons.add( jLabel_1_7 );
//          jPanelRadioButtons.add( jLabel_1_8 );

	  //-------------------------------------------------------------------------
	  //-------------------------------------------------------------------------
/*
	  jLabel_2_0.setText( "basionymity:" );
          jPanelRadioButtons.add( jLabel_2_0 );
          jRadioButtonUnkown2.setText ("unkown");
	  jRadioButtonUnkown2.addKeyListener( new java.awt.event.KeyAdapter ()
	  {
	      public void keyReleased( java.awt.event.KeyEvent evt )
	      {
                  setUnkown2();
	      }
	  }
          );
          jRadioButtonUnkown2.addActionListener (new java.awt.event.ActionListener ()
          {
              public void actionPerformed (java.awt.event.ActionEvent evt)
              {
                  setUnkown2();
              }
          }
          );
          jPanelRadioButtons.add( jRadioButtonUnkown2);
          jRadioButtonBasionym.setText( "basionym" );
	  jRadioButtonBasionym.addKeyListener( new java.awt.event.KeyAdapter ()
	  {
	      public void keyReleased( java.awt.event.KeyEvent evt )
	      {
                  setBasionym();
	      }
	  }
          );
          jRadioButtonBasionym.addActionListener (new java.awt.event.ActionListener ()
          {
              public void actionPerformed( java.awt.event.ActionEvent evt )
              {
                  setBasionym();
              }
          }
          );
          jPanelRadioButtons.add( jRadioButtonBasionym);
          jRadioButtonCombined.setText( "combined" );
	  jRadioButtonCombined.addKeyListener( new java.awt.event.KeyAdapter ()
	  {
	      public void keyReleased( java.awt.event.KeyEvent evt )
	      {
                  setCombined();
	      }
	  }
          );
          jRadioButtonCombined.addActionListener( new java.awt.event.ActionListener ()
          {
              public void actionPerformed (java.awt.event.ActionEvent evt)
              {
                  setCombined();
              }
          }
          );
          jPanelRadioButtons.add( jRadioButtonCombined);
          jPanelRadioButtons.add( jLabel_2_4 );
	  jPanelRadioButtons.add( jLabel_2_5 );
          jPanelRadioButtons.add( jLabel_2_6 );
//          jPanelRadioButtons.add( jLabel_2_7 );
//          jPanelRadioButtons.add( jLabel_2_8 );
*/

	  //-------------------------------------------------------------------------
	  //-------------------------------------------------------------------------
	  jLabel_3_0.setText( "validity:" );
          jRadioButtonUnkown3.setText( "unkown" );
	  jRadioButtonUnkown3.addKeyListener( new java.awt.event.KeyAdapter ()
	  {
	      public void keyReleased( java.awt.event.KeyEvent evt )
	      {
                  setUnkown3();
	      }
	  }
          );
          jRadioButtonUnkown3.addActionListener (new java.awt.event.ActionListener ()
          {
              public void actionPerformed (java.awt.event.ActionEvent evt)
              {
                  setUnkown3();
              }
          }
          );
          //--------------------------------------------------------------------
          jRadioButtonValid.setText( "valid" );
	  jRadioButtonValid.addKeyListener( new java.awt.event.KeyAdapter ()
	  {
	      public void keyReleased( java.awt.event.KeyEvent evt )
	      {
                  setValid();
	      }
	  }
          );
          jRadioButtonValid.addActionListener (new java.awt.event.ActionListener ()
          {
              public void actionPerformed (java.awt.event.ActionEvent evt)
              {
                  setValid();
              }
          }
          );
          //--------------------------------------------------------------------
          jRadioButtonNomenNudum.setText( "nom.nud." );
	  jRadioButtonNomenNudum.addKeyListener( new java.awt.event.KeyAdapter ()
	  {
	      public void keyReleased( java.awt.event.KeyEvent evt )
	      {
                  setNomenNudum();
	      }
	  }
          );
          jRadioButtonNomenNudum.addActionListener (new java.awt.event.ActionListener ()
          {
              public void actionPerformed (java.awt.event.ActionEvent evt)
              {
                  setNomenNudum();
              }
          }
          );
          //--------------------------------------------------------------------
          jRadioButtonNomenIlleg.setText( "nom.illeg." );
	  jRadioButtonNomenIlleg.addKeyListener( new java.awt.event.KeyAdapter ()
	  {
	      public void keyReleased( java.awt.event.KeyEvent evt )
	      {
                  setNomenIlleg();
	      }
	  }
          );
          jRadioButtonNomenIlleg.addActionListener (new java.awt.event.ActionListener ()
          {
              public void actionPerformed (java.awt.event.ActionEvent evt)
              {
                  setNomenIlleg();
              }
          }
          );
          //--------------------------------------------------------------------
          jRadioButtonNomenInvalid.setText( "nom. invalid." );
	  jRadioButtonNomenInvalid.addKeyListener( new java.awt.event.KeyAdapter ()
	  {
	      public void keyReleased( java.awt.event.KeyEvent evt )
	      {
                  setNomenInvalid();
	      }
	  }
          );
	  jRadioButtonNomenInvalid.addActionListener (new java.awt.event.ActionListener ()
          {
              public void actionPerformed (java.awt.event.ActionEvent evt)
              {
                  setNomenInvalid();
              }
          }
          );
          //--------------------------------------------------------------------
          jRadioButtonAuct.setText ("auct.");
	  jRadioButtonAuct.addKeyListener( new java.awt.event.KeyAdapter ()
	  {
	      public void keyReleased( java.awt.event.KeyEvent evt )
	      {
                  setAuct();
	      }
	  }
          );
	  jRadioButtonAuct.addActionListener (new java.awt.event.ActionListener ()
          {
              public void actionPerformed (java.awt.event.ActionEvent evt)
              {
                  setAuct();
              }
          }
          );
//          jPanelRadioButtons.add( jRadioButtonAuct);
          //--------------------------------------------------------------------
          jRadioButtonAgg.setText ("agg.");
	  jRadioButtonAgg.addKeyListener( new java.awt.event.KeyAdapter ()
	  {
	      public void keyReleased( java.awt.event.KeyEvent evt )
	      {
                  setAgg();
	      }
	  }
          );
	  jRadioButtonAuct.addActionListener (new java.awt.event.ActionListener ()
          {
              public void actionPerformed (java.awt.event.ActionEvent evt)
              {
                  setAgg();
              }
          }
          );
//          jPanelRadioButtons.add( jRadioButtonAgg );
          //--------------------------------------------------------------------
          jRadioButtonIned.setText ("ined.");
	  jRadioButtonIned.addKeyListener( new java.awt.event.KeyAdapter ()
	  {
	      public void keyReleased( java.awt.event.KeyEvent evt )
	      {
                  setIned();
	      }
	  }
          );
	  jRadioButtonIned.addActionListener (new java.awt.event.ActionListener ()
          {
              public void actionPerformed (java.awt.event.ActionEvent evt)
              {
                  setIned();
              }
          }
          );
//          jPanelRadioButtons.add( jRadioButtonIned);
          //--------------------------------------------------------------------
          jPanelRadioButtons.add( jLabel_3_0 );
          jPanelRadioButtons.add( jRadioButtonUnkown3);
          jPanelRadioButtons.add( jRadioButtonValid );
          jPanelRadioButtons.add( jRadioButtonNomenNudum );
          jPanelRadioButtons.add( jRadioButtonNomenIlleg );

//          jPanelRadioButtons.add( jLabel_4_0 );
//          jPanelRadioButtons.add( jLabel_4_1 );
          jPanelRadioButtons.add( jLabel_4_2 );
          jPanelRadioButtons.add( jRadioButtonNomenInvalid);
          jPanelRadioButtons.add( jRadioButtonAuct);
          jPanelRadioButtons.add( jRadioButtonAgg );
          jPanelRadioButtons.add( jRadioButtonIned);
//          jPanelRadioButtons.add( jLabel_4_3 );
//          jPanelRadioButtons.add( jLabel_4_4 );
//          jPanelRadioButtons.add( jLabel_4_5 );
//          jPanelRadioButtons.add( jLabel_4_6 );
//          jPanelRadioButtons.add( jLabel_4_7 );
//          jPanelRadioButtons.add( jLabel_4_8 );

          add( jPanelRadioButtons);


	//-------------------------------------------------------------------------
	// Taxonomic Rank (flags)
	//-------------------------------------------------------------------------
        InputRankFlags jPanelRankFlags = new InputRankFlags();
        add( jPanelRankFlags );
	//-------------------------------------------------------------------------
	// Output Line
	//-------------------------------------------------------------------------

	jLabelOutputLine.setText( "..." );
	jLabelOutputLine.setHorizontalAlignment( javax.swing.SwingConstants.CENTER );
	jLabelOutputLine.setVerticalAlignment(   javax.swing.SwingConstants.CENTER );

//	jPanelOutputLine.setLayout( new java.awt.FlowLayout( 0, 5, 5) );
	jPanelOutputLine.add( jLabelOutputLine );
//        add( jPanelOutputLine );

	//-------------------------------------------------------------------------
	//-------------------------------------------------------------------------
	// Literature (taxon)
	//--------------------
          jPanelLiterature.setLayout( new java.awt.FlowLayout (0, 5, 5) );

	  //jPanelLiterature.setMaximumSize(   new java.awt.Dimension( 600, 30 ) );
	  //jPanelLiterature.setMinimumSize(   new java.awt.Dimension( 600, 30 ) );
	  //jPanelLiterature.setPreferredSize( new java.awt.Dimension( 600, 30 ) );
	  jPanelLiterature.setSize( new java.awt.Dimension( 600, 30 ) );

            jLabelLiterature.setText( "Literature (taxon) ");
            jPanelLiterature.add( jLabelLiterature);
            jTextFieldLiterature.setPreferredSize( new java.awt.Dimension( 200, 16) );
            jTextFieldLiterature.setMinimumSize(   new java.awt.Dimension( 200, 16) );
            jTextFieldLiterature.setText( "" );
            jTextFieldLiterature.addActionListener (new java.awt.event.ActionListener()
            {
                public void actionPerformed (java.awt.event.ActionEvent evt)
                {
                    jTextFieldLiteratureActionPerformed (evt);
                }
            }
            );
            jPanelLiterature.add( jTextFieldLiterature);
            jLabelLiteratureYear.setText (" Year ");
            jPanelLiterature.add( jLabelLiteratureYear );
            jTextFieldLiteratureYear.setPreferredSize( new java.awt.Dimension( 50, 16) );
            jTextFieldLiteratureYear.setMinimumSize(   new java.awt.Dimension( 50, 16) );
            jTextFieldLiteratureYear.setText( "" );
            jTextFieldLiteratureYear.addActionListener( new java.awt.event.ActionListener()
            {
                public void actionPerformed (java.awt.event.ActionEvent evt)
                {
                    jTextFieldLiteratureYearActionPerformed (evt);
                }
            }
            );
        add( jPanelOutputLine );
            jPanelLiterature.add( jTextFieldLiteratureYear);
         add( jPanelLiterature);
	 //------------------------------------
	 // Operational geographical unit: type
	 //------------------------------------
//          jPanel_OGU_type.setLayout (new java.awt.FlowLayout (0, 5, 5));
            jPanel_OGU.setLayout( new java.awt.GridLayout( 3, 2 ) );
            jLabel_OGU_type.setText ("Operational geographical unit: type ");
//            jPanel_OGU_type.add( jLabel_OGU_type );
            jTextField_OGU_type.setPreferredSize( new java.awt.Dimension( 200, 16 ) );
            jTextField_OGU_type.setMinimumSize(   new java.awt.Dimension( 200, 16 ) );
            jTextField_OGU_type.setText ( "" );
            jTextField_OGU_type.addActionListener (new java.awt.event.ActionListener()
            {
                public void actionPerformed (java.awt.event.ActionEvent evt)
                {
                    jTextField_OGU_typeActionPerformed (evt);
                }
            }
            );
//            jPanel_OGU_type.add( jTextField_OGU_type);
//          add( jPanel_OGU_type );

	  ///---------------------------------------------
	  // Operational geographical units: distribution
	  ///---------------------------------------------
//          jPanel_OGU_distribution.setLayout (new java.awt.FlowLayout (0, 5, 5));
            jLabel_OGU_distribution.setText ( "Operational geographical units: distribution " );
//            jPanel_OGU_distribution.add( jLabel_OGU_distribution );
            jTextField_OGU_distribution.setPreferredSize( new java.awt.Dimension( 200, 16 ) );
            jTextField_OGU_distribution.setMinimumSize(   new java.awt.Dimension( 200, 16 ) );
            jTextField_OGU_distribution.setText( "" );
            jTextField_OGU_distribution.addActionListener (new java.awt.event.ActionListener ()
            {
                public void actionPerformed (java.awt.event.ActionEvent evt)
                {
                    jTextField_OGU_distributionActionPerformed (evt);
                }
            }
            );
            jPanel_OGU.add( jLabel_OGU_distribution );
            jPanel_OGU.add( jTextField_OGU_distribution );
            jPanel_OGU.add( jLabel_OGU_type );
            jPanel_OGU.add( jTextField_OGU_type);

	  jLabelNotice.setText( "Notice :" );
	  jPanel_OGU.add( jLabelNotice );

//            jPanel_OGU_distribution.add( jTextField_OGU_distribution );
//          add( jPanel_OGU_distribution );
          add( jPanel_OGU );

	  //----------
	  // Notice
	  //----------

//          jPanelNotice.setLayout( new java.awt.FlowLayout( 0, 5, 5 ) );
//	  jPanelNotice.setMaximumSize(   new java.awt.Dimension( 780, 250 ) );
//	  jPanelNotice.setMinimumSize(   new java.awt.Dimension( 780, 250 ) );
//	  jPanelNotice.setPreferredSize( new java.awt.Dimension( 780, 250 ) );
//	  jLabelNotice.setText( "Notice" );
//	  jPanelNotice.add( jLabelNotice );
/*
	  jTextAreaNotice.setMinimumSize(   new java.awt.Dimension( 780, 150 ) );
	  jTextAreaNotice.setPreferredSize( new java.awt.Dimension( 780, 150 ) );
	  jPanelNotice.add( jTextAreaNotice );
*/


          javax.swing.JEditorPane edit = new javax.swing.JEditorPane();

	  // edit.setMinimumSize(   new java.awt.Dimension( 680, 150 ) );
	  // edit.setPreferredSize( new java.awt.Dimension( 680, 150 ) );

          javax.swing.JScrollPane ScrollPane = new  javax.swing.JScrollPane( edit );
          // ScrollPane.setMinimumSize(   new java.awt.Dimension( 760, 150 ) );
          ScrollPane.setPreferredSize( new java.awt.Dimension( 760, 50 ) );
          ScrollPane.setAutoscrolls( true );
	  jPanelNotice.add( ScrollPane );

          add( jPanelNotice );

	  //------------
	  // Reference
	  //------------
          jPanelReference.setLayout( new java.awt.FlowLayout( 0, 5, 5 ) );
	  jLabelReference.setText( "Reference" );
	  jPanelReference.add( jLabelReference );
	  jTextFieldReference.setPreferredSize( new java.awt.Dimension( 150, 16) );
	  jTextFieldReference.setMinimumSize(   new java.awt.Dimension( 150, 16) );
	  jTextFieldReference.setText ("");
	  jPanelReference.add( jTextFieldReference );
	  jLabelReferenceAuthor.setText ("(OGU), author, year");
	  jPanelReference.add( jLabelReferenceAuthor );
          add( jPanelReference);
    }

    private void showOutputLine()
    {
	java.lang.StringBuffer out = new java.lang.StringBuffer();

	if( jTextFieldGenus.getText().trim().length() != 0 )
	    out.append( jTextFieldGenus.getText()      + " " );

	if( jTextFieldSpecies.getText().trim().length() != 0 )
	    out.append( jTextFieldSpecies.getText()    + " " );

	if( jTextFieldSubSpecies.getText().trim().length() != 0 )
	    out.append( "sub. " + jTextFieldSubSpecies.getText() + " " );

	if( jTextFieldVariety.getText().trim().length() != 0 )
	    out.append( "var. " + jTextFieldVariety.getText()    + " " );

	if( jTextFieldForm.getText().trim().length() != 0  )
	    out.append( "f. " + jTextFieldForm.getText()       + " " );

	if( jTextFieldFirst.getText().trim().length() != 0 )
	    out.append( "(" + jTextFieldFirst.getText()     + ")" );

	if( jTextFieldAuthor.getText().trim().length() != 0 )
	    out.append( " " + jTextFieldAuthor.getText()     + " " );

	jLabelOutputLine.setText( out.toString() );
	jLabelOutputLine.setVisible( true );
    }


    private void jTextField_OGU_distributionActionPerformed (java.awt.event.ActionEvent evt)
    {
    }

    private void jTextField_OGU_typeActionPerformed (java.awt.event.ActionEvent evt)
    {
    }
    private void jTextFieldLiteratureYearActionPerformed (java.awt.event.ActionEvent evt)
    {
    }
    private void jTextFieldLiteratureActionPerformed (java.awt.event.ActionEvent evt)
    {
    }
    private void jTextFieldAuthorActionPerformed (java.awt.event.ActionEvent evt)
    {
    }
    private void jTextFieldFormActionPerformed (java.awt.event.ActionEvent evt)
    {
    }
    private void jTextFieldFirstActionPerformed (java.awt.event.ActionEvent evt)
    {
    }
    private void jTextFieldVarietyActionPerformed (java.awt.event.ActionEvent evt)
    {
    }
    private void jTextFieldSubSpeciesActionPerformed (java.awt.event.ActionEvent evt)
    {
    }
    private void jTextFieldSpeciesActionPerformed (java.awt.event.ActionEvent evt)
    {
    }
    private void jTextFieldGenusActionPerformed (java.awt.event.ActionEvent evt)
    {
    }


    //--------------------
    // 1. RadioButtol Line
    //--------------------
    private void clearRadioButtonLine_1()
    {
	    jRadioButtonUnkown1.setSelected( false );
	    jRadioButtonNonSynonym.setSelected( false );
	    jRadioButtonSynonym.setSelected( false );
    }

    //    private void jRadioButtonUnkown1ActionPerformed (java.awt.event.ActionEvent evt)
    private void setUnkown1()
    {
	clearRadioButtonLine_1();
	jRadioButtonUnkown1.setSelected( true );
    }
    private void setNonSynonym()
    {
	clearRadioButtonLine_1();
	jRadioButtonNonSynonym.setSelected( true );
    }
    private void setSynonym()
    {
	clearRadioButtonLine_1();
	jRadioButtonSynonym.setSelected( true  );
    }
    //--------------------
    // 2. RadioButtol Line
    //--------------------
    private void clearRadioButtonLine_2()
    {
	jRadioButtonUnkown2.setSelected( false );
	jRadioButtonBasionym.setSelected( false );
	jRadioButtonCombined.setSelected( false );
    }
    private void setUnkown2()
    {
	clearRadioButtonLine_2();
	jRadioButtonUnkown2.setSelected( true );
    }
    private void setBasionym()
    {
	clearRadioButtonLine_2();
	jRadioButtonBasionym.setSelected( true );
    }
    private void setCombined()
    {
	clearRadioButtonLine_2();
	jRadioButtonCombined.setSelected( true );
    }

    //--------------------
    // 3. RadioButtol Line
    //--------------------
    private void clearRadioButtonLine_3()
    {
	jRadioButtonUnkown3.setSelected( false );
	jRadioButtonValid.setSelected( false );
	jRadioButtonNomenNudum.setSelected( false );
	jRadioButtonNomenIlleg.setSelected( false );
	jRadioButtonNomenInvalid.setSelected( false );
	jRadioButtonAuct.setSelected( false );
	jRadioButtonAgg.setSelected( false );
	jRadioButtonIned.setSelected( false );
    }

    private void setUnkown3()
    {
	clearRadioButtonLine_3();
	jRadioButtonUnkown3.setSelected( true );
    }
    private void setValid()
    {
	clearRadioButtonLine_3();
	jRadioButtonValid.setSelected( true );
    }
    private void setNomenNudum()
    {
	clearRadioButtonLine_3();
	jRadioButtonNomenNudum.setSelected( true );
    }
    private void setNomenIlleg()
    {
	clearRadioButtonLine_3();
	jRadioButtonNomenIlleg.setSelected( true );
    }
    private void setNomenInvalid()
    {
	clearRadioButtonLine_3();
	jRadioButtonNomenInvalid.setSelected( true );
    }
    private void setAuct()
    {
	clearRadioButtonLine_3();
	jRadioButtonAuct.setSelected( true );
    }
    private void setAgg()
    {
	clearRadioButtonLine_3();
	jRadioButtonAgg.setSelected( true );
    }
    private void setIned()
    {
	clearRadioButtonLine_3();
	jRadioButtonIned.setSelected( true );
    }
/*
    public static void main(String args[])
    {
        new TaxonFrame ().show ();
        System.out.println( "start taxon" );
        Taxon taxon = new Taxon();
        taxon.show();
    }
*/
}


