/*
 * CharacterStateElement.java
 *
 * Created on 13. Februar 2004, 19:14
 */

package net.metadiversity.diversity.navigator.db.delta_editor;

import org.apache.log4j.Logger;
/**
 *
 * @author  didi
 */
public class CharacterStateElement implements java.lang.Comparable        
{
    static Logger logger = Logger.getLogger( CharacterStateElement.class.getName() ); 

    public final static String  TYPE_STRING_RN = "RN";  // real number
    public final static String  TYPE_STRING_UM = "UM";  // unordert Multistate
    public final static String  TYPE_STRING_IN = "IN";  // integer number
    public final static String  TYPE_STRING_OM = "OM";  // orderd multistat
    public final static String  TYPE_STRING_TE = "TE";  // text element
    
    public final static int     TYPE_UNKOWN = 0x0000;
    public final static int     TYPE_RN     = 0x0001;
    public final static int     TYPE_UM     = 0x0002;
    public final static int     TYPE_IN     = 0x0004;
    public final static int     TYPE_OM     = 0x0008;    
    public final static int     TYPE_TE     = 0x0010;
    
    
    private boolean selected;
    private String  type;
    private String  name;
    //------------------------------------------------------------------
    public CharacterStateElement( String type, String name )
    {
        this.selected = false;
        this.type = type;
        this.name = name;
    }
    //------------------------------------------------------------------
    public CharacterStateElement( boolean selected, String type, String name )
    {
        this.selected = selected;
        this.type = type;
        this.name = name;
    }           
    //------------------------------------------------------------------
    public void setSelected( boolean b )
    {
        selected = b;
    }
    //------------------------------------------------------------------
    public Boolean isSelected()
    {
        if( selected )
            return Boolean.valueOf( true  );
        else
            return Boolean.valueOf( false );
    }
    //------------------------------------------------------------------
    public String getName()
    {
        return name;
    }            
    //------------------------------------------------------------------
    public String getTypeString()
    {
        return type;
    }
    //------------------------------------------------------------------
    /*
    public int getType()
    {
        return type;
    }
     */
    public int compareTo( Object o )
    {
        String comp = ((CharacterStateElement) o ).type;
        int x, y;
        try
        {          
            x = Integer.parseInt( comp );
        }
        catch( java.lang.NumberFormatException ex )
        {          
            if( comp.equalsIgnoreCase("-" ) )       x = Integer.MAX_VALUE -1;
            else
            if( comp.equalsIgnoreCase("U" ) )       x = Integer.MAX_VALUE -2;
            else
            if( comp.equalsIgnoreCase("V" ) )       x = Integer.MAX_VALUE -3;
            else
            if( comp.equalsIgnoreCase("TE" ) )      x = Integer.MAX_VALUE -4;
            else
            if( comp.equalsIgnoreCase("Min" ) )     x = Integer.MAX_VALUE -5;
            else
            if( comp.equalsIgnoreCase("-Low" ) )    x = Integer.MAX_VALUE -6;
            else
            if( comp.equalsIgnoreCase("Mean" ) )    x = Integer.MAX_VALUE -7;
            else
            if( comp.equalsIgnoreCase("+High" ) )   x = Integer.MAX_VALUE -8;
            else
            if( comp.equalsIgnoreCase("Max" ) )     x = Integer.MAX_VALUE -9;
            else
            x = Integer.MAX_VALUE;
        }
        try
        {          
            y = Integer.parseInt( this.type );
        }
        catch( java.lang.NumberFormatException ex )
        {  
            if( this.type.equalsIgnoreCase("-" ) )  y = Integer.MAX_VALUE -1;
            else
            if( this.type.equalsIgnoreCase("U" ) )  y = Integer.MAX_VALUE -2;
            else
            if( this.type.equalsIgnoreCase("V" ) )  y = Integer.MAX_VALUE -3;
            else
            if( this.type.equalsIgnoreCase("TE" ) ) y = Integer.MAX_VALUE -4;
            else
            if( this.type.equalsIgnoreCase("Min" ) ) y = Integer.MAX_VALUE -5;
            else
            if( this.type.equalsIgnoreCase("-Low" ) ) y = Integer.MAX_VALUE -5;
            else
            if( this.type.equalsIgnoreCase("Mean" ) ) y = Integer.MAX_VALUE -7;
            else
            if( this.type.equalsIgnoreCase("+High" ) ) y = Integer.MAX_VALUE -8;
            else
            if( this.type.equalsIgnoreCase("Max" ) ) y = Integer.MAX_VALUE -9;
            else
            y = Integer.MAX_VALUE;
        }
        if( x == y ) return 0;
        if( x < y )  return 1;
        else return -1;
    }
       
}
