/*
 * ProjectQueryTreeRenderer.java
 *
 * Created on 14. November 2003, 17:56
 */

package net.metadiversity.diversity.navigator.gui;

import org.apache.log4j.Logger;

import java.awt.Component;
import javax.swing.*;
//import javax.swing.tree.*;

import net.metadiversity.diversity.navigator.*;

/**
 *
 * @author  Dieter Neubacher
 */
public class ProjectQueryTreeRenderer extends javax.swing.tree.DefaultTreeCellRenderer
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3544392526023636785L;
    
    static Logger logger = Logger.getLogger( ProjectQueryTreeRenderer.class.getName() );
    
    /** Creates a new instance of ProjectQueryTreeRenderer */
    public ProjectQueryTreeRenderer()
    {
    }
    
    public Component getTreeCellRendererComponent( JTree tree, Object value, boolean selected, boolean expanded, boolean leaf, int row, boolean hasFocus)
    {
        super.getTreeCellRendererComponent( tree, value, selected, expanded, leaf, row, hasFocus );
        
        // get user element
        // javax.swing.tree.DefaultMutableTreeNode node = ( javax.swing.tree.DefaultMutableTreeNode ) value;               
        // String str = (String) node.getUserObject();
        
        String str = (String) value.toString();

        int level = 0;
        int pos;
        
        while( (pos = str.indexOf( '.' )) > 0 )
        {
            level++;
            str = str.substring( pos + 1 );
        }
        
        // str = str.substring( str.lastIndexOf( '.' ) + 1 );
        
        switch( level )
        {
            /*
            case 0 :                
                super.setIcon( DiversityNavigatorProperties.getDbTreeRootIcon() );
                break;
             */
            case 1 :                
                super.setIcon( DiversityNavigatorProperties.getDbTreeProjectIcon() );
                break;
            case 2 :                
                super.setIcon( DiversityNavigatorProperties.getDbTreeDBGroupIcon() );
                break;
            case 3 :
                super.setIcon( DiversityNavigatorProperties.getDbTreeDatabaseIcon() );
                break;
            case 4 :
                super.setIcon( DiversityNavigatorProperties.getDbTreeTableIcon() );
                break;
            case 5 :
                super.setIcon( DiversityNavigatorProperties.getDbTreeFieldIcon() );
                break;
        }
        
        super.setText( str );
/*        
        DBNode node = ( DBNode ) value;        
        switch( node.getNodeType() )
        {
            case DBNode.NODE_TYPE_CAPTION_CONNECTIONS :                
                super.setIcon( DiversityNavigatorProperties.getDbTreeRootIcon() );
                break;
            case DBNode.NODE_TYPE_DATABASE :
                super.setIcon( DiversityNavigatorProperties.getDbTreeDatabaseIcon() );
                break;
            case DBNode.NODE_TYPE_TABLE :
                super.setIcon( DiversityNavigatorProperties.getDbTreeTableIcon() );
                break;
            case DBNode.NODE_TYPE_FIELD :
                super.setIcon( DiversityNavigatorProperties.getDbTreeFieldIcon() );
                break;
        }
 */
        return this;
   }
}
