package net.metadiversity.diversity.navigator.gui;

import org.apache.log4j.Logger;

import java.sql.*;

/**
   Dieses Klasse verwendet einen bildlauff�higen Cursor (ein
   JDBC 2-Feature), um Elemente der Ergebnismenge zu lokalisieren.
*/
class QueryScrollingResultSetTableModel extends QueryResultSetTableModel
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3257291313920751671L;
    static Logger logger = Logger.getLogger( QueryScrollingResultSetTableModel.class.getName() );
    /**
      Konstruiert das Tabellenmodell.
      @param aResultSet Anzuzeigende Ergebnismenge
    */
    public QueryScrollingResultSetTableModel( ResultSet aResultSet )
    {
        super( aResultSet );
    }
    //---------------------------------------------------------------------------
    //---------------------------------------------------------------------------
    public Object getValueAt( int r, int c )
    {
        try
        {
            ResultSet rs = getResultSet();
            rs.absolute( r + 1 );
            return rs.getObject( c + 1 );
        }
        catch( SQLException ex )
        {
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
            return null;
        }
    }
    //---------------------------------------------------------------------------
    //---------------------------------------------------------------------------
    public int getRowCount()
    {
        try
        {
            ResultSet rs = getResultSet();
            rs.last();
            return rs.getRow();
        }
        catch( SQLException ex )
        {
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
            return 0;
        }
    }
}