/*
 * UbtCollectionProjectPlugin.java
 *
 * Created on 18. November 2003, 16:15
 */

package net.metadiversity.diversity.navigator.projectPlugin;

import org.apache.log4j.Logger;

import net.metadiversity.diversity.navigator.gui.delta_editor.DeltaEditor;
import net.metadiversity.diversity.navikey.ui.NaviKey;
import net.metadiversity.diversity.navigator.gui.DnOptionPane;

/**
 *
 * @author  Dieter Neubacher
 */
public class LocalDiversityDescriptionsLiasLightProjectPlugin extends Plugin
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 4049080427819840566L;
    static Logger logger = Logger.getLogger( DiversityDescriptionsLiasLightProjectPlugin.class.getName() );
    
    /** Creates a new instance of UbtCollectionProjectPlugin */
    public LocalDiversityDescriptionsLiasLightProjectPlugin()
    {
        super( "LIAS Light", "Diversity Workbench" );

        String delta_editor_database = "Local LIAS Light";
        addProjectDatabase( null, delta_editor_database );
        
        String diversity_taxon_names_database = "Diversity Taxon Names Fungi";
        addProjectDatabase( null, diversity_taxon_names_database );
        
        String diversity_accepted_names_cache_database = "Local AcceptedNames";
        addProjectDatabase( null, diversity_accepted_names_cache_database );

        java.sql.Connection connectionAcceptedNames = null;          
        java.sql.Connection namesConnection = null;        
        java.sql.Connection con = null;        

        net.metadiversity.diversity.navigator.connection.ConnectionInfo ci;        
        try
        {
            ci = net.metadiversity.diversity.navigator.connection.ConnectionsManager.getConnectionInfoByName( delta_editor_database );
            logger.info( "Connect to: " + ci.getUrl() );
            con = ci.getConnection();
        }
        catch( java.sql.SQLException ex )
        {
             logger.error( ex.getMessage(), ex.fillInStackTrace() );
             DnOptionPane.DnShowErrorDialog( ex.getMessage() );
        }
        catch( Exception ex )
        {
             logger.error( ex.getMessage(), ex.fillInStackTrace() );
             DnOptionPane.DnShowErrorDialog( ex.getMessage() );
        }
        try
        {
            ci = net.metadiversity.diversity.navigator.connection.ConnectionsManager.getConnectionInfoByName( diversity_taxon_names_database );
            logger.info( "Connect to: " + ci.getUrl() );
            namesConnection = ci.getConnection();
        }
        catch( java.sql.SQLException ex )
        {
             logger.error( ex.getMessage(), ex.fillInStackTrace() );
             DnOptionPane.DnShowErrorDialog( ex.getMessage() );
        }
        catch( Exception ex )
        {
             logger.error( ex.getMessage(), ex.fillInStackTrace() );
             DnOptionPane.DnShowErrorDialog( ex.getMessage() );
        }
        try
        {
            ci = net.metadiversity.diversity.navigator.connection.ConnectionsManager.getConnectionInfoByName( diversity_accepted_names_cache_database );
            logger.info( "Connect to: " + ci.getUrl() );
            connectionAcceptedNames = ci.getConnection();
            
        }
        catch( java.sql.SQLException ex )
        {
             logger.error( ex.getMessage(), ex.fillInStackTrace() );
             DnOptionPane.DnShowErrorDialog( ex.getMessage() );
        }
        catch( Exception ex )
        {
             logger.error( ex.getMessage(), ex.fillInStackTrace() );
             DnOptionPane.DnShowErrorDialog( ex.getMessage() );
        }
        
        if( con == null )
        {
             DnOptionPane.DnShowErrorDialog( "Can't connect to description database");
//             return;
        }
        if( namesConnection == null )
        {
             DnOptionPane.DnShowErrorDialog( "Can't connect to names database");
//             return;
        }
        if( connectionAcceptedNames == null )
        {
             DnOptionPane.DnShowErrorDialog( "Can't connect to AcceptedNamesCache database");
//             return;
        }
        String tablePrefix = "LIASlight";
        
        logger.info( "init DeltaEditor" );
        DeltaEditor p = new DeltaEditor( con, namesConnection, connectionAcceptedNames, tablePrefix, true );
        this.setGridViewPanel( p );
        
        
        
        logger.info( "init data for Navikey" );
        String specs = p.getSpecsString();
        String chars = p.getCharsString();
        String items = p.getItemsString();
        
        logger.info( "init Navikey" );
        NaviKey navikey = new NaviKey( (java.awt.Container) getIdentificationPanel(), specs, chars, items );
        try 
        {            
            navikey.init();
        } 
        catch( java.lang.Exception ex ) 
        {
             logger.error( ex.getMessage(), ex.fillInStackTrace() );
             DnOptionPane.DnShowErrorDialog( ex.getMessage() );            
        }
        
        // this.setSelectedIndex( 2 ); // Show Grid
        this.showGrid();
        this.pack();
        this.setVisible( true );
    }
}
