/*
 * DnBooleanRenerer.java
 *
 * Created on 10. August 2002, 14:27
 */

package net.metadiversity.diversity.navigator.types;

import java.awt.*;
import java.awt.Component;
import javax.swing.*;
import javax.swing.table.*;

import net.metadiversity.diversity.navigator.*;     // icons
import org.apache.log4j.Logger;
  
public class DnBooleanTableCellRenderer implements TableCellRenderer
{
    static Logger logger = Logger.getLogger( DnBooleanTableCellRenderer.class.getName() );
    
    private JLabel label = new JLabel();
    private int    val   = 0;
    
    static boolean debugFlag = false;
       
    public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column)
    {  
        if( debugFlag && logger.isDebugEnabled() )
        {    
            logger.debug( "getTableCellRendererComponent( row : " + row + " col : " + column + " )" );
            logger.debug( "isSelected : " + isSelected );
            logger.debug( "hasFocus :   " + hasFocus  );
        }
        
        int val = 0;
        try
        {
            val = ((DnBoolean) value).getValue();    
        }
        catch( ClassCastException ex )
        {
            logger.error( ex.getLocalizedMessage() );
        }
        

        switch( val )
        {
           case -1 :
                    label.setText( "false" );
                    label.setIcon( DiversityNavigatorProperties.getCheckboxFalseIcon() );
                    break;
           case 0  :
                    label.setText( "null" );
                    label.setIcon( DiversityNavigatorProperties.getCheckboxNullIcon() );
                    break;
           case 1  :
                    label.setText( "true" );
                    label.setIcon( DiversityNavigatorProperties.getCheckboxTrueIcon() );
                    break;
        }
        label.setMaximumSize( new Dimension( 16, 50 ) );
        
        return label;
    }
}
