/*
 * BarImage.java
 *
 * Created on December 6, 2006, 1:10 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package net.metadiversity.diversity.navigator.util;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.sql.CallableStatement;
import java.sql.DatabaseMetaData;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.sql.SQLWarning;
import java.sql.Savepoint;
import java.sql.Statement;
import java.util.Map;

/**
 *
 * @author didi
 */
public class BarImage 
{
    private final static int colorValues = 16;
    private final static int boxSize     = 6;
    private final static int width       = 8;
    
    private final static int OBS   = 1;
    private final static int CHARS = 80;

    private final static String COLOR_ICON_PATH = "icons/";
    
    private final static java.awt.Color color [] = 
    {
        java.awt.Color.RED,         // 1
        java.awt.Color.BLUE,        // 2
        java.awt.Color.CYAN,        // 3
        java.awt.Color.DARK_GRAY,
        java.awt.Color.GREEN,
        java.awt.Color.LIGHT_GRAY,  // 6
        java.awt.Color.MAGENTA,
        java.awt.Color.GRAY,
        java.awt.Color.ORANGE,
        java.awt.Color.PINK,        // 10
        java.awt.Color.WHITE,
        java.awt.Color.YELLOW,
        java.awt.Color.BLACK,       // 13
        new java.awt.Color(153, 0, 204),
        new java.awt.Color(255, 204, 51),
        new java.awt.Color(190, 240, 66)
    };        
/* Jan Color's    
    cc0000,"ff6666","ffcccc","660000","996666","cc00cc","ff66ff","ffccff","660066","996699","0000cc","6666ff","ccccff","66","666699","00cccc","66ffff","ccffff","6666","669999","00cc00","66ff66","ccffcc","6600","669966","ffff00","ffff99","cccc00","666600","999966","ff9900","cc6600","993300","99cc33","0099ff","ff3399","660099","996600","9966","999999","666666"
*/
    java.awt.image.BufferedImage image;
            
    /** Creates a new instance of BarImage */
    public BarImage() 
    {
        
    }
    //
    // Create Color Icons
    //
    public void createColorIcons( int size, int colorIndex )
    {
        image = new java.awt.image.BufferedImage( size, size, java.awt.image.BufferedImage.TYPE_INT_RGB );
        int grid = 1;
        for( int x = grid; x <  size - grid; x++ )
        {                                            
            for( int y = grid; y < size - grid ; y++ )
            {
                image.setRGB( x, y, color[ colorIndex % colorValues ].getRGB() );                  
            }
        }           
        String filename = "Color_" + colorIndex + ".png";
        saveImage( filename );
    }
    //
    // create the image
    //
    public void createImage( String filename, java.util.Vector values )
    {
        int size = 2;
        
        for( int i = 0; i < values.size(); i++ )
        {
            size += boxSize * (Integer) values.get( i ); 
        }            
        image = new java.awt.image.BufferedImage( width, size, java.awt.image.BufferedImage.TYPE_INT_RGB );
        
        System.out.println( filename + " " + width + " " + size );
        paint( values );
        saveImage( filename );
    }
    public void createImageAndLegende( int obs, int characterIndex, String filename, java.util.Vector values, String characterName, java.util.Vector charStateNames  )
    {
        createImage( filename + ".png", values );
        
        // Legende
        
        StringBuffer table = new StringBuffer();

        table.append( "<%@ page contentType=\"text/html\"%>" ); // JSP 
        table.append( "<%@ page pageEncoding=\"UTF-8\"%>"    ); // JSP       
        table.append( "<p>" +  characterName + "<p>" );
        table.append( "<table>" );
        
        String colorIcon;
        String text;
        for( int i = 0; i < values.size(); i++ )
        {   
            colorIcon = "Color_" + i + ".png";
            text      = "<td>" + (String) charStateNames.get( i ) + "</td>";
// JAVA SCRIPT            table.append( "<tr><td><img src=\\\"" + colorIcon + "\\\"></td><td>" + text + "</td></tr>");
            table.append( "<tr><td><img src=\"" + COLOR_ICON_PATH + colorIcon + "\"></td>" + text + "</tr>");
        }
        table.append( "</table>" );
//        table.append( "\"," );
        try 
        {
            StringBuffer number = new StringBuffer();
            
            if( characterIndex < 10 )
                number.append( "0" );
            if( characterIndex < 100 )
                number.append( "0" );
            number.append( characterIndex );
            
            java.io.FileWriter fw = new java.io.FileWriter( "Legend_" + number + ".jsp" );
            
            fw.write( table.toString() );
            fw.close();
        } 
        catch (IOException ex) 
        {
            ex.printStackTrace();
        }
        //
        // Table only display uesd States, and show data
        //
        table = new StringBuffer();
        table.append( "<p>" +  characterName + "<p>" );
        table.append( "<table>" );
        
        for( int i = 0; i < values.size(); i++ )
        {   
            int val = (Integer) values.get( i );
            if( val > 0 )
            {
                colorIcon = "Color_" + i + ".png";
                text      = "<td>" + val + "</td><td>" + (String) charStateNames.get( i ) + "</td>";
                table.append( "<tr><td><img src=\\\"" + colorIcon + "\\\"></td>" + text + "</tr>");
            }    
        }
        table.append( "</table>" );
//        table.append( "\"," );
        try 
        {
            StringBuffer number = new StringBuffer();
            
            if( obs < 10 )
                number.append( "0" );
            number.append( obs );
            number.append( "_" );
            if( characterIndex < 10 )
                number.append( "0" );
            if( characterIndex < 100 )
                number.append( "0" );
            number.append( characterIndex );
            
            java.io.FileWriter fw = new java.io.FileWriter( "Legend_" + number + ".txt" );
            
            fw.write( table.toString() );
            fw.close();
        } 
        catch (IOException ex) 
        {
            ex.printStackTrace();
        }
    }
    //
    // paint the bar
    //
    private void paint( java.util.Vector values )
    {
        int boxNumber = 0;
        
        for( int i = 0; i < values.size(); i++ )
        {
            for( int n = (Integer) values.get( i ); n > 0; n-- )
            {
                fill( boxNumber, color[ i % colorValues] );
                boxNumber++;
            }
        }
    }
    //
    // fill a box with color
    //
    private void fill( int boxNumber, java.awt.Color color )
    {
        int offsetX = 0;
        int offsetY = boxNumber * boxSize;
                
        int grid = 1;
        
        for( int x = grid; x < width - grid; x++ )
        {                                            
            for( int y = grid; y < boxSize - grid ; y++ )
            {
                image.setRGB( offsetX + x, offsetY + y, color.getRGB() );                  
            }
        }        
    }
    public void saveImage( String filename )
    {
        File file;
        file = new java.io.File( filename );

        String format = "PNG"; // JPEG" "PNG" "BMP"
        try 
        {
            javax.imageio.ImageIO.write( image, format, file);
        } 
        catch (IOException ex) 
        {
            ex.printStackTrace();
        }
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main( String[] args ) 
    {   
        /*
        int [] obsVector = { 1,2,3,4,5,6,8,10,11,12,16,17,18,20,21,22,24,25,26,27,28,29,31,32,33 };
        
        try                 
        {
            String charNumber = "039";                    
            for( int i = 1; i < 24; i++ )
            {    
                int obs = obsVector[ i ];
                
                String o;
                if( obs < 10 )        
                    o = "0" + Integer.toString( obs );
                else
                    o = Integer.toString( obs );
                
                String filename = "Legend_" + o + "_" + charNumber + ".txt";
                                
                java.io.FileReader fr = new java.io.FileReader( filename );

                int ch;
                try 
                {
                    System.out.print( "     " );
                    
                    while( (ch = fr.read()) > 0  )
                    {
                        System.out.print( (char) ch );
                    }
                    fr.close();
                    System.out.println();
                } 
                catch( IOException ex ) 
                {
                    ex.printStackTrace();
                }
            }
        } 
        catch( FileNotFoundException ex ) 
        {
            ex.printStackTrace();
        }
        */

        
        BarImage bi = new BarImage();

        for( int i = 0; i < 1; i++ )
        {    
            bi.createColorIcons( 8, i );
        }
        System.out.println( "EXIT" ); 
        System.exit( 0 );
                      
        //----------------------------------
        // Build connection to Collection DB
        //----------------------------------
        String MS_SQL_DRIVER_CLASS      = "net.sourceforge.jtds.jdbc.Driver";
        String POSTGRESQL_DRIVER_CLASS  = "org.postgresql.Driver";
        
        java.sql.Connection conCollection = null;
              
        String col_url  = "jdbc:jtds:sqlserver://141.84.65.157:5432/DiversityCollection";
        String col_user = "BiotaLichensColl";
        String col_pwd  = "mu1/27ssGR";
                
        try
        {
            System.out.println( "Load " + MS_SQL_DRIVER_CLASS );
            Class.forName( MS_SQL_DRIVER_CLASS );
        }
        catch( java.lang.ClassNotFoundException ee )
        {
            System.out.println( "ClassNotFoundException: " );
            System.out.println( ee.getMessage() );
            
            System.exit( 1 );
        }
        try
        {
            conCollection = java.sql.DriverManager.getConnection( col_url, col_user, col_pwd );
        }            
        catch( java.sql.SQLException ex )
        {
            System.out.println( ex.getMessage() );             
            System.exit( 2 );
        }
   
        //-----------------------------------
        // Build connection to Description DB
        //-----------------------------------
        java.sql.Connection conDescription = null;
              
        String des_url  = "jdbc:postgresql://141.84.65.158:5432/DiversityDescriptions_LIASlight_051015";
        String des_user = "asif";
        String des_pwd  = "9para,cha";

        try
        {
            System.out.println( "Load "  + POSTGRESQL_DRIVER_CLASS );
            Class.forName( POSTGRESQL_DRIVER_CLASS );
        }
        catch( java.lang.ClassNotFoundException ee )
        {
            System.out.println( "ClassNotFoundException: " );
            System.out.println( ee.getMessage() );
            
            System.exit( 3 );
        }
        try
        {
            conDescription = java.sql.DriverManager.getConnection( des_url, des_user, des_pwd );
        }            
        catch( java.sql.SQLException ex )
        {
            System.out.println( ex.getMessage() );             
            System.exit( 4 );
        }        
        //----------------------------------------------------------------------
        
        
        
        
        //----------------------------------------------------------------------
        // Build the BarImages for GoogleMaps
        

        
        java.util.Random random = new java.util.Random();                
        String s;
                
        for( int obs = 1; obs <= OBS; obs++ )
        {
            for( int ch = 0; ch < CHARS; ch++)
            {                
                // build filename
                
                StringBuffer filename = new StringBuffer( "obs" );
                
                if( obs < 10 ) filename.append( "0" );
                filename.append( obs );
                filename.append( "_char0" );
                if( ch < 10 ) filename.append( "0" );
                filename.append( ch );
                filename.append( ".png" );

                java.util.Vector values = new java.util.Vector();
                
                
                int chars = random.nextInt( 25 );
                int h;
                for( int n = 0; n < chars; n++ )
                {
                    h = random.nextInt( 6 ) - 2;
                    if( h < 0 ) h = 0;
                    values.add( new Integer( h ) );
                }
                
                bi.createImage( filename.toString(), values );
            }    
        }
    }    
}
