/*
 * DatabaseTableDataTransfer.java
 *
 * Created on 19. Juni 2006, 10:05
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package net.metadiversity.diversity.navigator.util;

import java.sql.*;

/**
 *
 * @author didi
 */
public class DatabaseTableDataTransfer 
{
    private static String src_url;
    private static String src_user;
    private static String src_pwd;
    private static String src_TableName;
    
    private static String dest_url;
    private static String dest_user;
    private static String dest_pwd;
    private static String dest_TableName; 
    
    private static String MS_SQL_DRIVER_CLASS = "net.sourceforge.jtds.jdbc.Driver";
    private static String POSTGRESQL_DRIVER_CLASS = "org.postgresql.Driver";
    
    
    
    /** Creates a new instance of DatabaseTableDataTransfer */
    public DatabaseTableDataTransfer() 
    {
        
    }
    
     /**
     * @param args the command line arguments
     */
    public static void main( String[] args ) 
    {    
        Connection srcCon   = null;
        Connection destCon  = null;
       
        
        if( args.length < 8 )
        {
            System.out.println( "Usage: SourceDB-URL SourceDB-User SourceDB-PWD SourceDB-TableName DestinationDB-URL DestinationDB-User DestinationDB-PWD DestinationDB-TableName " );
            //------------------------------------------------------------------
            /*
            src_url         = "jdbc:jtds:sqlserver://141.84.65.122:1433/DiversityCollectionCache";
            src_user        = "www";
            src_pwd         = "********";
            src_TableName   = "CollectionProject";
            //------------------------------------------------------------------
            dest_url        = "jdbc:postgresql://141.84.65.114:5432/TestCache";
            dest_user       = "didi";
            dest_pwd        = "********";
            dest_TableName  = "CollectionProject_tmp"; 
             */
            //------------------------------------------------------------------
        }
        else
        {
            src_url         = args[ 0 ];
            src_user        = args[ 1 ];
            src_pwd         = args[ 2 ];
            src_TableName   = args[ 3 ];

            dest_url        = args[ 4 ];
            dest_user       = args[ 5 ];
            dest_pwd        = args[ 6 ];
            dest_TableName  = args[ 7 ]; 
        }
        
        
        //-------------------------------
        // Build connection to Source DB
        //-------------------------------
        
        // "jdbc:jtds:sqlserver://141.84.65.123:5432/SchnittlerChecklistDatabaseCache"        
              
        try
        {
            System.out.println( "Load " + MS_SQL_DRIVER_CLASS );
            Class.forName( MS_SQL_DRIVER_CLASS );
        }
        catch( java.lang.ClassNotFoundException ee )
        {
            System.out.println( "ClassNotFoundException: " );
            System.out.println( ee.getMessage() );
            
            System.exit( 1 );
        }
        try
        {
            srcCon = java.sql.DriverManager.getConnection( src_url, src_user, src_pwd );
        }            
        catch( java.sql.SQLException ex )
        {
            System.out.println( ex.getMessage() );             
            System.exit( 2 );
        }
   
        //-------------------------------
        // Build connection to Destination DB
        //-------------------------------
        try
        {
            System.out.println( "Load "  + POSTGRESQL_DRIVER_CLASS );
            Class.forName( POSTGRESQL_DRIVER_CLASS );
        }
        catch( java.lang.ClassNotFoundException ee )
        {
            System.out.println( "ClassNotFoundException: " );
            System.out.println( ee.getMessage() );
            
            System.exit( 3 );
        }
        try
        {
            destCon = java.sql.DriverManager.getConnection( dest_url, dest_user, dest_pwd );
        }            
        catch( java.sql.SQLException ex )
        {
            System.out.println( ex.getMessage() );             
            System.exit( 4 );
        }        
/*  
 * Not working with Microsoft SQL-Server
 *      
        //----------------------------------------------------------------------
        // Table Field Names
        
        String src_catalog = "DiversityCollectionCache";
        String src_schemaPattern  = "";
        String src_tableNamePattern = ""; // src_TableName;
        String src_columnNamePattern = "";
        
        System.out.println( "------------------------");
        System.out.println( "Source TableColumnNames: ");
        System.out.println( "------------------------");
        
        java.sql.ResultSet src_res;
        try 
        {
            src_res = srcCon.getMetaData().getColumns( src_catalog, src_schemaPattern, src_tableNamePattern, src_columnNamePattern );
            
            while( src_res.next() )
            {
                System.out.println( src_res.getString( 4 ) + "\t " + src_res.getString( 6 )  + "\t " + src_res.getString( 7 ));
            }
        } 
        catch (SQLException ex) 
        {
            ex.printStackTrace();
        }
  */      
        //----------------------------------------------------------------------
        // Table Field Names
        //----------------------------------------------------------------------
        
        String catalog = "";
        String schemaPattern  = "";
        String tableNamePattern = dest_TableName;
        String columnNamePattern = "";
        
        
        System.out.println( "-------------------------------");
        System.out.println( "Destionation TableColumnNames: ");
        System.out.println( "-------------------------------");
        
        
        java.util.Vector columnNames = new java.util.Vector();
        
        java.sql.ResultSet res;
        try 
        {
            res = destCon.getMetaData().getColumns( catalog, schemaPattern, tableNamePattern, columnNamePattern );
            
            while( res.next() )
            {
                System.out.println( res.getString( 4 ) + "\t " + res.getString( 6 )  + "\t " + res.getString( 7 ));
                columnNames.add( res.getString( 4 ) ); // store columnNames
            }
        } 
        catch (SQLException ex) 
        {
            ex.printStackTrace();
        }
        //----------------------------------------------------------------------
        // Copy Data to destination Database
        //----------------------------------------------------------------------


            StringBuffer sqlInsertStatement = new StringBuffer();
            StringBuffer sqlFields = new StringBuffer();
            StringBuffer sqlValues = new StringBuffer();
            
            sqlInsertStatement.append( "INSERT INTO " + "\"" + dest_TableName + "\" ( " );
            // add fields
            for( int i = 0; i < columnNames.size(); i++ )
            {   
                if( i > 0 )
                {
                    sqlFields.append( ", ");
                    sqlValues.append( ", ");
                }
                sqlFields.append( "\"" + columnNames.get( i ) + "\"" );
                sqlValues.append( "?");
            }
            String sql =  sqlInsertStatement.toString() + sqlFields.toString() + ") VALUES ( " + sqlValues.toString() +" );";
            System.out.println( sql );
            
            java.sql.PreparedStatement pstmt;
            try 
            {
                pstmt = destCon.prepareStatement( sql );
                

                int columnSize = columnNames.size();     


                String src_select = "SELECT * FROM " + src_TableName;
                
                java.sql.Statement stmt = srcCon.createStatement();
              
                java.sql.ResultSet src_dataResultSet = stmt.executeQuery( src_select ); 
                
                while( src_dataResultSet.next() )
                {
                    pstmt.clearParameters();                
                    for( int c = 0; c < columnSize; c++ )
                    {
                        
                        // System.out.println( (String) columnNames.get( c ) + " " +  src_dataResultSet.getString( c + 1 ) );

                        pstmt.setString( c + 1, src_dataResultSet.getString( c + 1 ) );
                    }
                    pstmt.execute();
                }
            } 
            catch (SQLException ex) 
            {
                ex.printStackTrace();
            }            
        }      
}
